#declare c_H2O_abs = rgb <0.272, 0.046, 0.010>; //at 1 meter
#declare c_Sea = <0.004, 0.012, 0.020>; //H2O scattering trial&error
/*
From: Trevor G Quayle
Date: 19 Dec 2008 21:25:00
                          */ 

#if (normhf)
            #declare ASiz=250;
            #declare RHIT=0.25;
            #declare FREQ=15;
            #declare WDep=63;    // 64 and 65 used in TQ_water_hf
            #declare WHit=0.45;
            #declare TDep=WDep+WHit+RHIT+1;
            
            #declare TFunk1=function{max(min(abs(x),1)-0.5,0)/(1-0.5)}
            
            #declare PPIG3= //Pool Side Ripples
              pigment {
                function{TFunk1(x,y,z)}
                pigment_map{
                  [0.0 rgb 0]
                  [1.0 function{TFunk1(x,y,z)} frequency ASiz/FREQ sine_wave]
                }
                scale 1/2
                poly_wave 3
                translate x*1/2
                scale 5
                warp{turbulence 0.05*x}
                scale 1/5
                warp{turbulence 0.05*x}
              }
            
            #declare WCol=rgb <0.51373, 0.70588, 0.70588>; //Water colour
            #local FD=-60/ln(0.58);                        //Fade distance
            #declare RScal=1/10;
            #declare RFreq=50;
            
            #declare SRip =
            function{
              pigment {
                marble
                frequency ASiz/RFreq*RScal
                scale 1/5
                warp{turbulence 1.5}
                scale 5
                warp{turbulence 0.5}
                sine_wave
                scale RScal
              }
            }
            
            #local FTILEA = function {SRip(x,y,z).gray*0.5+SRip(y,x,z).gray*0.5}
            #local FTILEB = function {pigment{PPIG3 }}
            #local FTILEC = function {pigment{PPIG3 rotate z*90}}
            
            #declare aaa=WHit/TDep;
            #declare bbb=RHIT/TDep;
            
            #local FTILE = function
            {FTILEA(x,y,z)*aaa+FTILEB(x,y,z).gray*bbb+FTILEC(x,y,z).gray*bbb+(1-aaa-bbb*2)}
            
            #declare WW2=
            height_field{
              function 600,600 {pattern{function{FTILE(x,y,z)}}}
              smooth
              hollow
              scale <ASiz,TDep,ASiz>
            }
            
            #declare MWater=
              material{
                texture{
                  pigment{rgbt 1}
                  finish{conserve_energy  diffuse 0.0  ambient 0  reflection{0 1 fresnel on
            metallic 0}}
                }
                interior{
                  ior 1.33
                  media{
                    absorption c_H2O_abs
                    #if (1) scattering { 3, c_Sea } #end
                    density{rgb 1/FD}
                  }
                }
              }
            
            #declare TQ_water_hf =
            intersection{
              box { <-8.5, -65, -8.5> <216.5, 1, 216.5>}
              object{WW2 translate <-10,-64,-10>}
              hollow
              material { MWater translate <-10,0,-10>}
              translate y*-1   //  translate z*1
            }
#else
// as normals
            #declare ASiz=250;
            #declare RHIT=0.25;
            #declare FREQ=15;
            #declare WDep=65;
            #declare WHit=0.45;
            #declare TDep=WDep+WHit+RHIT+1;
            
            #declare TFunk1=function{max(min(abs(x),1)-0.5,0)/(1-0.5)}
            
            #declare PPIG3= //Pool Side Ripples
              pigment {
                function{TFunk1(x,y,z)}
                pigment_map{
                  [0.0 rgb 0]
                  [1.0 function{TFunk1(x,y,z)} frequency ASiz/FREQ sine_wave]
                }
                scale 1/2
                poly_wave 3
                translate x*1/2
                scale 5
                warp{turbulence 0.05*x}
                scale 1/5
                warp{turbulence 0.05*x}
              }
            
            //#declare WCol=rgb <0.51373, 0.70588, 0.70588>; //Water colour
            #local FD=-60/ln(0.58);                        //Fade distance 110.146882
            
            #declare RScal=1/10;
            #declare RFreq=50;
            
            #declare SRip =
            function{
              pigment {
                marble
                frequency ASiz/RFreq*RScal
                scale 1/5
                warp{turbulence 1.5}
                scale 5
                warp{turbulence 0.5}
                sine_wave
                scale RScal
              }
            }
            
            #local FTILEA = function {SRip(x,y,z).gray*0.5+SRip(y,x,z).gray*0.5}
            #local FTILEB = function {pigment{PPIG3 }}
            #local FTILEC = function {pigment{PPIG3 rotate z*90}}
            
            #declare THit=WHit+RHIT*2;
            #local FTILE2 = function
            {FTILEA(x,y,z)*WHit/THit+FTILEB(x,y,z).gray*RHIT/THit+FTILEC(x,y,z).gray*RHIT/THit}
            
            #declare MWater=
              material{
                texture{
                  pigment { rgbt 1 }
                  finish { conserve_energy  diffuse 0.0  ambient 0
                    reflection{0 1 fresnel on metallic 0}
                  }
                  normal { function{FTILE2(x,z,y)} scale <ASiz,TDep,ASiz> bump_size 0.1}
                }
                interior {
                  ior 1.33
                  media{
                    absorption c_H2O_abs
                    #if (1) scattering { 3, c_Sea } #end
                    density{rgb 1/FD}
                  }
                }
              }
            
            #declare TQ_water_n =
            object {
              box { <-8.2, -66, -8.2> <216.2, -1, 216.2> }
              hollow
              material { MWater translate <-10,0,-10>}
            }
#end