                        #declare sceneY =1;
#include "shapes.inc"
#include "colors.inc"
//#include "textures.inc"
#include "echo.inc"
//#include "shapes2.inc"
#declare c_H2O_abs = rgb <0.272, 0.046, 0.010>; //at 1 meter
#declare c_Sea = <0.004, 0.012, 0.020>; //H2O scattering trial&error
#declare n_Sea = normal {
         function { f_ridge (x, y, z, 0.1, 1.0, 7, 0.7, 0.7, 0) } 2
}
  #declare normhf = 0;
#include "TQ_water.pov"
#include "triangulation.inc"

#version 3.63;
#include "text.pov"

global_settings {   
    assumed_gamma 1.9
}

/// /////////////////////////// CAMERA pitch roll speed ///////////////////////////////////
#declare ZeroPrlx = 1.6;  #declare EyeSep = .01; #declare _stereo_ = 0;

#macro movecam(cl)       //execute 5 deg roll in 6 frames
#local d = 5;
  #if (cl < 24) #declare roll = -d *   (cl    /6); #declare roll = _clamp(roll,-d,0); #end
  #if (cl >= 24) #declare roll = -d+d*((cl-24)/6); #declare roll = _clamp(roll,-d,0); #end // return 0 in 6

  #local d = 8.5;
  #if (cl > 42) #declare roll = -d *  ((cl-42)/6); #declare roll = _clamp(roll,-d,0); #end
  #if (cl > 54) #declare roll = -d +d*((cl-54)/6); #declare roll = _clamp(roll,-d,0); #end  // return 0 in 6
  
  #if (cl > 57) #declare pitch = -.9 *    ((cl-57)/6); #declare pitch = _clamp(pitch,-1,1); #end
  #if (cl > 66) #declare pitch = -1 +  1 *((cl-66)/2); #declare pitch = _clamp(pitch,-1,1); #end// hard up 2 deg in 4
  #if (cl > 72) #declare pitch =  1 + -1 *((cl-72)/6); #declare pitch = _clamp(pitch,0,1); #end  // return 0 in 6
  #if (cl > 80) #declare pitch =  2 *     ((cl-80)/4); #declare pitch = _clamp(pitch,0,2); #end // hard up 2 deg in 4
  
  #local d = 16;   
  #if (cl > 82) #declare roll = d * ((cl-82) / 11); #declare roll = _clamp(roll,0,d); #end
  
  #declare Eye = rotation(radians(pitch/2),Right,Eye);
  #declare Eye = rotation(radians(roll/-5.3333333),y,Eye);

  #declare campos = campos + Eye * 20;
#end

#macro setmat(Up,eye)
  #local e = vnormalize(eye);
  #local r = vnormalize(vcross(Up,e));
  #local U = vnormalize(vcross(e,r)); 
  #declare cameramatrix = array[16] { r.x,r.y,r.z,0,U.x,U.y,U.z,0,e.x,e.y,e.z,0,0,0,0,1 }
#end

#macro camview(pitch,roll)
  #declare Up = rotation(radians(roll),Eye,Up);
  #declare Right = vnormalize(vcross(Up,Eye));
  #declare Eye = rotation(radians(pitch),Right,Eye);
  #declare Up = vnormalize(vcross(Eye,Right));
  setmat(Up,Eye)
#end
//////////////////////////////// Cam Control \\\\\\\\\\\\\\\\\\\\\\\\\\\
#declare roll = 0;
#declare pitch = 0;
#declare startpnt = <220, 35, 320.0>;
#declare campos = startpnt;
#declare Eye = vnormalize(<3240,0,1800> - startpnt);
#declare Up = y;
#declare Right = vnormalize(vcross(Up,Eye));
#declare Up = vnormalize(vcross(Eye,Right));
                
/// /////////////////////////// CLOCK movecam \\\\\\\\\\\\\\\\\\\\\\\\\\\ 
#macro stepcam(fr)
  #local i = 1;
  #while (i <= fr) 
    movecam(i)
    #local i=i+1;
  #end
#end

#declare frame = clock;
//#declare frame = 11;
stepcam(frame)                         
/// ////////////////////////////// CAMERA \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ 
#declare camang = 43;
camview(pitch,roll)
camera {
  #if (_stereo_)
    stereoscopic
    zeroparallax ZeroPrlx
    eyeseparation EyeSep
  #end 
  location campos
  right Right
  up Up*(image_height/image_width)
  direction Eye*(image_height/image_width)
  angle camang
}
   #declare Info = 10;
#if (Info)    
          // azalt()
 // InfoDisplay()
  InfoDisplay2(concat("Frame: ",str(frame,0,0)),18.8)
 // InfoDisplay2(concat("Azimuth ",str(aza[0],0,2)),14)
 InfoDisplay2(concat("Az ",str(360 - _rascension(),0,2)),16.6)
 InfoDisplay2(concat("Dec ",str(_declination(),0,2)),14.4)
 InfoDisplay2(concat("Roll ",str(roll,0,2)),12.2)
 InfoDisplay2(concat("Alt ",str(campos.y,0,2)),10)
#end
/// ////////////////////// LIGHTS /////////////////////
#declare MainLight = color rgb <0.8,0.8,0.8>*1.4;
#declare FillLight = color rgb <0.23,0.23,0.25>;
   
#declare T1=
 texture{
   pigment{
     granite color_map{[0.0 Black][1.0 White]}
     scale 0.24
   }
}
light_source { <100, 200 + sceneY, -100.0> MainLight }
light_source { <-2800, 700 + sceneY, 2400.0> FillLight }

#declare nice = color White;
#declare nice2 = color rgb <.2, .2 ,.8>;
       
#macro pce(hf,tx,tz,mxev)
echo(hf) cr()
height_field {
  tga hf   // x 0-1.0 y 0-1.0 z 0-1.0
  smooth
  // water_level 0.0 pigment { White }
  pigment {
    gradient y
    color_map {
      [0.0 color <0.25 , 0.25 , 1.0>]
      [0.01 color <0.2 , 0.4 , 0.25>]
      [0.1 color <.2 , 0.5 , 0.0>]
      // [0.3 color <.3 , 0.4 , 0.0>]
      [0.2 color <.4 , 0.3 , 0.0>]
      [0.5 color <.3,.18 , 0.32>]
      [0.9 color <.2,.18 , 0.22>]
      [0.95 color <1,1,1>]
      [1.0 color <0.25 , 0.25 , 1.0>]
    }
    //scale  1
  }
  finish {
    crand 0.025         // dither  - not used often, but this image needs it.
    ambient 0.2         // Very dark shadows
    diffuse 0.8         // Whiten the whites
    //phong 0.2          // shiny
    // phong_size 100.0    // with tight highlights
    // specular 0.5
    roughness 0.15
  }
  translate <tx, 0,tz>
  scale < 300, 35, 300 >
}
#end

#declare Glass = texture {
   pigment {rgbft < 0.98, 1.0, 0.98,.02,.95> }
   finish {
      specular 1
      roughness 0.001
      ambient 0
      diffuse 0
      reflection {
         0,1
         fresnel
      }
   }
}
#macro _all()
#local n = .988;   
pce( "hawaii-e.tga" , 1 *n, 0 *n,0)
pce( "hawaii-s.tga" , 0 *n, 1 *n,0)
pce( "hawaii-c.tga" , 1 *n, 1 *n,0)
pce( "hawaii-n.tga" , 2 *n, 1 *n,0)
pce( "hawaii-w.tga" , 1 *n, 2 *n,0)
pce( "maui-se.tga" , 2 *n, 2 *n,0)
pce( "maui-ne.tga" , 3 *n, 2 *n,0)
pce( "maui-sw.tga" , 2 *n, 3 *n,0)
pce( "maui-nw.tga" , 3 *n, 3 *n,0)
pce( "oahu.tga" , 3 *n, 4 *n,0)
pce( "kauai-se.tga" , 3 *n, 5 *n,0)
pce( "kauai-ne.tga" , 4 *n, 5 *n,0)
pce( "kauai-sw.tga" , 3 *n, 6 *n,0)
pce( "kauai-nw.tga" , 4 *n, 6 *n,0)

#end                

  #include "skies.inc" 
    /*
sphere { <0,0,0>, 10000
    texture {
        T_Cloud1
        scale 700
    }
} 
*/


plane{<0,1,0>,10000  
      
      texture{ pigment {color rgb< 0.05,0.25,0.6>}
               finish {ambient 1  diffuse 0}}
      }                    
#declare planeclouds = plane{<0,1,0>,2000
      texture{pigment { bozo turbulence 0.65
                        octaves 6  omega 0.7 lambda 2 
                       /* color_map { [0.0 color rgb <0.95, 0.95, 0.95>*0.5]
                                    [0.1 color rgb <0.85, 0.85, 0.85>*1.5]
                                    [0.5 color rgbt <1, 1, 1, 1> ]
                                    [1.0 color rgbt <1, 1, 1, 1> ]   }*/
          color_map {
                          [0.0  color rgb <0.95, 0.95, 0.95> ]
                          [0.05  color rgb <1, 1, 1>*1.25 ]
                          [0.15 color rgb <0.85, 0.85, 0.85> ]
                          [0.55 color rgbt <1, 1, 1, 1>*1 ]
                          [1.0 color rgbt <1, 1, 1, 1>*1 ]
                    } // end color_map                                     
                        rotate<20,20,0> translate<0,0,-0.4>
                         scale <50, 1, 50>
                        scale 10
                        
                }
                        finish { ambient 1 diffuse 0}
  
      } 
          //scale 1.0
         // rotate x*3
        // translate z * 360000
     } 
     
 #declare lake_mcCloud = 
object {
cylinder { <.2,-.5,.2,>, <0.2,.21,.2>, .1 hollow }
  material { MWater } // translate <-10,0,-10>}
  translate <0,-.2,.95 + .5>
  scale < 1200, 1200.0, 1200 >*.4
}
#declare S_Cloud22 =
sky_sphere {
    pigment {
        gradient y
        pigment_map {
            [0.00 rgb <0.847, 0.749, 0.847> ] // horizon
            [0.10 SkyBlue ]                   // horizon
            [0.20 P_Cloud3 ]
        }
    }
}

//sky_sphere { S_Cloud22 }    
   
   #declare ior_NaCl_H2O = 1.34; //35g/l
#declare seawater = material {
       texture
       {  pigment { rgbf 1 }
          finish
          {  reflection { 0 0.5 fresnel } conserve_energy
             specular 1 roughness 0.01
          }
          #if (1) normal { n_Sea } #end
       }
       interior
       {  #if (1) ior ior_NaCl_H2O #end
          media 
          {  absorption c_H2O_abs
             #if (1) scattering { 3, c_Sea } #end
             method 3
             intervals 1
             samples 3, 3
             aa_level 2         
          }
       }
}
#declare poolwater = material {
       texture
       {  pigment { rgbf 1 }
          finish
          {  reflection { 0 0.1 fresnel } conserve_energy
             specular .052 roughness 0.01
          }
          #if (1) normal { n_Sea scale 7 } #end
       }
       interior
       {  #if (1) ior ior_NaCl_H2O #end
          media 
          {  absorption c_H2O_abs
             #if (1) scattering { 3, c_Sea } #end
             method 3
             intervals 1
             samples 3, 3
             aa_level 2         
          }
       }
}

#declare lightsaber = material {
texture
       {  pigment { rgbf 1 }
          finish
          {  reflection { 0 0.5 fresnel } conserve_energy
             specular 1 roughness 0.01
          }
          #if (1) normal { n_Sea } #end
       }
       interior
       {  #if (0) ior 1.5 #end
          media 
          {  //absorption <0.272, 0.046, 0.010>
             emission <.1, .1, 1>
             #if (1) scattering { 3, <0.004, 0.012, 0.020> } #end
             method 3
             intervals 1
             samples 3, 3
             aa_level 2         
          }
       }
}


// ground fog at the horizon -----------------------------------------
#declare Fog = fog { fog_type   2
     distance   400
     color      rgb<1,1,1>*0.7
     fog_offset 0.1
     fog_alt    2
     turbulence 1.8
}


#declare bright = .41; //.4
#declare Green1=rgb<0.4,1,0.3>*bright;
#declare Green2=rgb<60,160,8>/255;
// --------------------------------------
// Grass texture
// --------------------------------------

#declare pigSpotted2 = pigment {
spotted
    color_map {
        [0.0, 0.2   color Tan*0.1 color Tan*0.4]
        [0.2, 0.3   color Tan*0.4 color Green1]
        [0.3, 1.01   color Green1 color Green1*1.2]
    }
}
                                 
#declare pigEarth2 = pigment {
 spotted
 color_map {
  [0 color rgb<0.4,1,0.3>*0.4]
  [0.6 color Tan*0.3]
  [0.6 color Green1*0.4]
  [1   color Green1*0.4]
 }
}
#declare pigGreen=pigment{Green2*1.3}

#declare T_Grass=texture {                  
 pigment {
  gradient y
  turbulence 0.2
  pigment_map {                                
   [0.0 pigEarth2]
   [0.3 pigGreen]
   [0.9 pigSpotted2]
   [1.00 pigEarth2]
  }
 }
 finish{ambient 0.1 diffuse 0.7 specular 0.2 roughness 0.015}
 scale <0.001,1,0.001>
} 

#declare grass =
 plane{y,0
 texture { T_Grass scale 1 }
}
//grass
//planeclouds
union {
_all() 
//lake_mcCloud
translate y * sceneY
}
