                        #declare sceneY =-.25;
#include "shapes.inc"
#include "colors.inc"
#include "textures.inc"
#include "echo.inc"
//#include "shapes2.inc"
#declare c_H2O_abs = <0.272, 0.046, 0.010>; //at 1 meter
#declare c_water = <1,1,1> - c_H2O_abs;
#declare c_Sea = <0.004, 0.012, 0.020>; //H2O scattering trial&error
#declare n_Sea = normal {
         function { f_ridge (x, y, z, 0.1, 1.0, 7, 0.7, 0.7, 0) } 2
}
  #declare normhf = 0;
#include "TQ_water.pov"
#include "triangulation.inc"

#version 3.63;
#include "text.pov"

global_settings {   
    assumed_gamma 1.9
    max_trace_level 15
}

/// /////////////////////////// CAMERA pitch roll speed ///////////////////////////////////
#declare ZeroPrlx = 1.6;  #declare EyeSep = .01; #declare _stereo_ = 0;

#macro movecam(cl)       //execute 5 deg roll in 6 frames
#local d = 5;
  #if (cl < 24) #declare roll = -d *   (cl    /6); #declare roll = _clamp(roll,-d,0); #end
  #if (cl > 24) #declare roll = -d+d*((cl-24)/6); #declare roll = _clamp(roll,-d,0); #end  // return 0 in 6

  #local d = 8.5;
  #if (cl > 42) #declare roll = -d *  ((cl-42)/6); #declare roll = _clamp(roll,-d,0); #end
  #if (cl > 54) #declare roll = -d +d*((cl-54)/6); #declare roll = _clamp(roll,-d,0); #end  // return 0 in 6
  
  #if (cl > 57) #declare pitch = -.9 *    ((cl-57)/6); #declare pitch = _clamp(pitch,-1,1); #end
  #if (cl > 66) #declare pitch = -1 +  1 *((cl-66)/2); #declare pitch = _clamp(pitch,-1,1); #end// hard up 2 deg in 4
  #if (cl > 72) #declare pitch =  1 + -1 *((cl-72)/6); #declare pitch = _clamp(pitch, 0,1); #end // return 0 in 6
  #if (cl > 80) #declare pitch =  2 *     ((cl-80)/4); #declare pitch = _clamp(pitch, 0,2); #end// hard up 2 deg in 4
  
  #local d = 16;   
  #if (cl > 82) #declare roll = d * ((cl-82) / 11); #declare roll = _clamp(roll,0,d); #end
  
  #declare Eye = rotation(radians(pitch/2),Right,Eye);
  #declare Eye = rotation(radians(roll/-5.3333333),y,Eye);

  #declare campos = campos + Eye * 6.666667;
#end

#macro setmat(Up,eye)
  #local e = vnormalize(eye);
  #local r = vnormalize(vcross(Up,e));
  #local U = vnormalize(vcross(e,r)); 
  #declare cameramatrix = array[16] { r.x,r.y,r.z,0,U.x,U.y,U.z,0,e.x,e.y,e.z,0,0,0,0,1 }
#end

#macro camview(pitch,roll)
  #declare Up = rotation(radians(roll),Eye,Up);
  #declare Right = vnormalize(vcross(Up,Eye));
  #declare Eye = rotation(radians(pitch),Right,Eye);
  #declare Up = vnormalize(vcross(Eye,Right));
  setmat(Up,Eye)
#end
//////////////////////////////// Cam Control \\\\\\\\\\\\\\\\\\\\\\\\\\\
#declare roll = 0;
#declare pitch = 0;
#declare startpnt = <220, 35, 320.0>;
//#declare startpnt = <120, 35, 220.0>;
#declare campos = startpnt;
#declare Eye = vnormalize(<3240,0,1800> - startpnt);
#declare Up = y;
#declare Right = vnormalize(vcross(Up,Eye));
#declare Up = vnormalize(vcross(Eye,Right));
                
/// /////////////////////////// CLOCK movecam \\\\\\\\\\\\\\\\\\\\\\\\\\\ 
#macro stepcam(fr)
  #local i = 1;
  #while (i <= fr) 
    movecam(i)
    #local i=i+1;
  #end
#end

#declare frame = clock;
//#declare frame = 37;
stepcam(frame)                         
/// ////////////////////////////// CAMERA \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ 
#declare camang = 43;
camview(pitch,roll)
camera {
  #if (_stereo_)
    stereoscopic
    zeroparallax ZeroPrlx
    eyeseparation EyeSep
  #end 
  location campos
  right Right
  up Up*(image_height/image_width)
  direction Eye*(image_height/image_width)
  angle camang
}
   #declare Info = 10;
#if (Info)    
          // azalt()
 // InfoDisplay()
  InfoDisplay2(concat("Frame: ",str(frame,0,0)),18.8)
 // InfoDisplay2(concat("Azimuth ",str(aza[0],0,2)),14)
 InfoDisplay2(concat("Az ",str(360 - _rascension(),0,2)),16.6)
 InfoDisplay2(concat("Dec ",str(_declination(),0,2)),14.4)
 InfoDisplay2(concat("Roll ",str(roll,0,2)),12.2)
 InfoDisplay2(concat("Alt ",str(campos.y,0,2)),10)
#end    

/// ////////////////////// LIGHTS /////////////////////
#declare MainLight = color rgb <0.8,0.8,0.8>*1.4;
#declare FillLight = color rgb <0.23,0.23,0.25>;
   
#declare T1=
 texture{
   pigment{
     granite color_map{[0.0 Black][1.0 White]}
     scale 0.24
   }
} 

light_source { <100, 200 + sceneY, -100.0> MainLight }
light_source { <-2800, 700 + sceneY, 2400.0> FillLight }
#include "stones1.inc"
#include "mytextures.inc"
#declare T_Grnt111 =
texture {
pigment
 {granite
  turbulence 0.6
  color_map
   {[0.000, 0.154   color rgbt <0.890, 0.690, 0.690, 0.000>
                    color rgbt <0.996, 0.835, 0.737, 0.000>]
    [0.154, 0.308   color rgbt <0.996, 0.835, 0.737, 0.000>
                    color rgbt <0.745, 0.635, 0.651, 0.004>]
    [0.308, 0.444   color rgbt <0.745, 0.635, 0.651, 0.004>
                    color rgbt <0.733, 0.596, 0.557, 0.004>]
    [0.444, 0.615   color rgbt <0.733, 0.596, 0.557, 0.004>
                    color rgbt <0.996, 0.835, 0.737, 0.000>]
    [0.615, 0.803   color rgbt <0.996, 0.835, 0.737, 0.000>
                    color rgbt <0.765, 0.616, 0.659, 0.000>]
    [0.803, 1.001   color rgbt <0.765, 0.616, 0.659, 0.000>
                    color rgbt <0.890, 0.690, 0.690, 0.000>]
   }
 }
  //  normal { n_Sea scale 100 }
    //scale .01
 }
#macro pce(hf,tx,tz,mxev)
echo(hf) cr()
height_field {
  tga hf   // x 0-1.0 y 0-1.0 z 0-1.0
  smooth
  texture {
    gradient y
    texture_map {
      [0.0  t_1]
      [0.01 T_Grnt111]
      [0.1  t_3]
      [0.3  T_Stone11]
      [0.6  T_Grnt29]
      [0.9  t_6]
      [0.95 t_7]
      [1.0  t_1]
    }
  }
  translate <tx, 0,tz>
  scale < 300, 35, 300 >
}
#end


#macro _all()
#local n = .988;            
#if (frame < 18)         
pce( "hawaii-e.tga" , 1 *n, 0 *n,0)
pce( "hawaii-s.tga" , 0 *n, 1 *n,0)
pce( "hawaii-c.tga" , 1 *n, 1 *n,0)
pce( "hawaii-n.tga" , 2 *n, 1 *n,0)
pce( "hawaii-w.tga" , 1 *n, 2 *n,0) #end
#if (frame < 58)
pce( "maui-se.tga" , 2 *n, 2 *n,0)
pce( "maui-ne.tga" , 3 *n, 2 *n,0)
pce( "maui-sw.tga" , 2 *n, 3 *n,0)
pce( "maui-nw.tga" , 3 *n, 3 *n,0) #end
#if (frame < 70)
pce( "oahu.tga" , 3 *n, 4 *n,0)     #end   
pce( "kauai-se.tga" , 3 *n, 5 *n,0)
pce( "kauai-ne.tga" , 4 *n, 5 *n,0)
pce( "kauai-sw.tga" , 3 *n, 6 *n,0)
pce( "kauai-nw.tga" , 4 *n, 6 *n,0) 

#end                

#include "skies.inc" 
#declare sphsky = 
sphere { <0,0,0>, 10000
    texture {
        T_Cloud1
        scale 700
    }
} 

 #declare planesky =
plane{y,10000  
      
      texture{ pigment {color rgb< 0.05,0.25,0.6>}
               finish {ambient 1  diffuse 0}}
      }
#declare planegreen =      
plane{y,0
      
      texture{ pigment {color rgb< 0.05,0.15,0>}
               finish {ambient 1  diffuse 0}}
      }
                         
#declare planeclouds = plane{<0,1,0>,2000
      texture{pigment { bozo turbulence 0.65
                        octaves 6  omega 0.7 lambda 2
          color_map {
                          [0.0  color rgb <0.95, 0.95, 0.95> ]
                          [0.05  color rgb <1, 1, 1>*1.25 ]
                          [0.15 color rgb <0.85, 0.85, 0.85> ]
                          [0.55 color rgbt <1, 1, 1, 1>*1 ]
                          [1.0 color rgbt <1, 1, 1, 1>*1 ]
                    } // end color_map                                     
                        rotate<20,20,0> translate<0,0,-0.4>
                         scale <50, 1, 50>
                        scale 10
                        
                }
                        finish { ambient 1 diffuse 0}
  
      } 
          //scale 1.0
         // rotate x*3
        // translate z * 360000
     } 
     
 #declare lake_mcCloud = 
object {
cylinder { <.2,-.5,.2,>, <0.2,.21,.2>, .1 hollow }
  material { MWater } // translate <-10,0,-10>
  translate <0,-.2,.95 + .5>
  scale < 1200, 1200.0, 1200 >*.4
}
#declare S_Cloud22 =
sky_sphere {
    pigment {
        gradient y
        pigment_map {
            [0.00 rgb <0.847, 0.749, 0.847> ] // horizon
            [0.10 SkyBlue ]                   // horizon
            [0.20 P_Cloud3 ]
        }
        scale .01
    }
}

//sky_sphere { S_Cloud22 }    
   
   #declare ior_NaCl_H2O = 1.34; //35g/l
#declare seawater = material {
       texture
       {  pigment { rgbf 1 }
          finish
          {  reflection { 0 0.5 fresnel } conserve_energy
             specular 1 roughness 0.01
          }
          #if (1) normal { n_Sea } #end
       }
       interior
       {  #if (1) ior ior_NaCl_H2O #end
          media 
          {  absorption rgb c_H2O_abs
             #if (1) scattering { 3, c_Sea } #end
             method 3
             intervals 1
             samples 3, 3
             aa_level 2         
          }
       }
}
#declare poolwater = material {
       texture
       {  pigment { rgbf 1 }
          finish
          {  reflection { 0 0.1 fresnel } conserve_energy
             specular .052 roughness 0.01
          }
          #if (1) normal { n_Sea scale 7 } #end
       }
       interior
       {  #if (1) ior ior_NaCl_H2O #end
          media 
          {  absorption c_H2O_abs
             #if (1) scattering { 3, c_Sea } #end
             method 3
             intervals 1
             samples 3, 3
             aa_level 2         
          }
       }
}

#declare lightsaber = material {
texture
       {  pigment { rgbf 1 }
          finish
          {  reflection { 0 0.5 fresnel } conserve_energy
             specular 1 roughness 0.01
          }
          #if (1) normal { n_Sea } #end
       }
       interior
       {  #if (0) ior 1.5 #end
          media 
          {  //absorption <0.272, 0.046, 0.010>
             emission <.1, .1, 1>
             #if (1) scattering { 3, <0.004, 0.012, 0.020> } #end
             method 3
             intervals 1
             samples 3, 3
             aa_level 2         
          }
       }
}

 

#declare grass =
 plane{y,0
 texture { T_Grass scale 1 }
}
#declare Waves =
plane {
  y, 0
  pigment { color rgb c_water }
  finish {
    reflection 0.15
    ambient .3
    diffuse .1
  }
  //normal {
  //  bumps 0.2 scale 0.2
 // }
    normal {
          waves 0.1
          rotate y*45
          frequency 500
          scale 510
          phase clock*-.5
    } 
    translate <0,0,90>
    
}
#declare bluesky =
sky_sphere {
  pigment {
    gradient y
    color_map {
      [0.0 color rgb<0.34, 0.54 1.0>]
      [0.05 color rgb<0.2, 0.4, 1.0>]
      [0.4 color rgb<0.1, 0.1, 1.0>]
      [1.0 color rgb<0, 0, 1.0>]
    }
  }
}

#declare clouds =
disc {<0, 500, 0>, -y, 30000
  texture {
    pigment {
      wood
      scale 10000
      rotate<90, 0, 0>
      pigment_map{
        [0 bozo
           turbulence 2.95
           omega 0.1
           color_map {
             [0 color rgbt<1, 1, 1, 0>]
             [0.5 color rgbt<1, 1, 1, 1>]
           }
           scale 0.04]
        [1 color rgbt<1, 1, 1, 1>]
      }
    }
    finish { ambient 1 diffuse 0 }
    rotate <5, -45, 0>
    translate <10000,0,1199>
  }
}

#declare archcut =
difference {
  sphere { <0,0,0>, 41 }
  #declare i=0;
  #while (i<6)
    cylinder {
      z*50,z*-50,  10
      // open
      scale <1,3,1> 
      scale 1.15
      translate <0,-10,0>
      rotate <0,i*(180/6),0>
    } #declare i=i+1; #end
}
#declare apt =
union {
  difference {
    sphere { <0,0,0>, 40.5 }
    sphere { <0,0,0>, 39.5 }
    #declare i=0;
    #while (i<6)
    cylinder {
      z*50,z*-50,  10
      // open
      scale <1,3,1>
      scale 1.05 
      translate <0,-10,0>
      rotate <0,i*(180/6),0>
    } #declare i=i+1; #end 
    object { archcut }
    pigment { Gray95 }
  }
  sphere { <0,0,0>, 40
    texture { t_rad }
    hollow
  }
  difference {
    sphere { <0,0,0>,40 }
    cylinder { y*50,y*-50,25}
    pigment { Gray95 }
    scale <1,.01,1>
    translate <0,24.5,0>
  }
  sphere { <0,0,0>,
    45
    pigment { Gray95 }
    scale <1,.01,1>
    translate <0,12.3,0>
  }
  sphere { <0,0,0>,
    55
    pigment { Gray95 }
    scale <1,.0041,1>
    translate <0,.1,0>
  }
}
object { apt scale <1,0.7,1>/4 translate <300*3,0,300*3>}
//grass 
//planegreen
//planesky
//planeclouds
union {
_all() 
//lake_mcCloud
translate y * sceneY
}

sky_sphere {bluesky}
plane {Waves}
disc {clouds}